require "import"
import "android.content.Context"
import "android.content.Intent"
import "android.widget.Button"
import "android.widget.CheckBox"
import "android.widget.EditText"
import "android.widget.LinearLayout"
import "android.widget.TextView"
import "com.androlua.LuaDialog"
import "android.os.Vibrator"
local context = activity or service
local vibrator = context.getSystemService(Context.VIBRATOR_SERVICE)
vibrator.vibrate(100)
passwordGeneratorLayout = {
    LinearLayout;
    orientation = "vertical";
    {
        TextView;
        text = "Tamanho da senha:";
    };
    {
        EditText;
        hint = "Digite aqui o tamanho da senha que você deseja";
        id = "passwordLengthEdit";
    };
    {
        CheckBox;
        text = "Incluir letras maiúsculas";
        id = "includeUppercaseCheckbox";
    };
    {
        CheckBox;
        text = "Incluir letras minúsculas";
        id = "includeLowercaseCheckbox";
    };
    {
        CheckBox;
        text = "Incluir números";
        id = "includeNumbersCheckbox";
    };
    {
        CheckBox;
        text = "Incluir caracteres especiais";
        id = "includeSpecialCharsCheckbox";
    };
    {
        CheckBox;
        text = "Copiar senha";
        id = "copyPasswordCheckbox";
    };
    {
        CheckBox;
        text = "Salvar senha nos favoritos";
        id = "saveToFavoritesCheckbox";
    };
    {
        CheckBox;
        text = "Compartilhar senha";
        id = "sharePasswordCheckbox";
    };
    {
        Button;
        text = "Criar senha";
        onClick = function()
            local passwordLength = tonumber(passwordLengthEdit.text)
            local includeUppercase = includeUppercaseCheckbox.isChecked()
            local includeLowercase = includeLowercaseCheckbox.isChecked()
            local includeNumbers = includeNumbersCheckbox.isChecked()
            local includeSpecialChars = includeSpecialCharsCheckbox.isChecked()
            local copyPassword = copyPasswordCheckbox.isChecked()
            local saveToFavorites = saveToFavoritesCheckbox.isChecked()
            local sharePassword = sharePasswordCheckbox.isChecked()

            if passwordLength then
                local chars = ""
                if includeUppercase then
                    chars = chars .. "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
                end
                if includeLowercase then
                    chars = chars .. "abcdefghijklmnopqrstuvwxyz"
                end
                if includeNumbers then
                    chars = chars .. "0123456789"
                end
                if includeSpecialChars then
                    chars = chars .. "!@#$%^&*()_+[]{}|;:,.<>?~"
                end

                if chars == "" then
                    service.asyncSpeak("Vui lòng chọn ít nhất một tùy chọn")
vibrator.vibrate(200)
                else
                    local password = ""
                    for i = 1, passwordLength do
                        local randomIndex = math.random(1, #chars)
                        password = password .. chars:sub(randomIndex, randomIndex)
                    end
                    service.asyncSpeak("Mật khẩu ngẫu nhiên của bạn là: " .. password)
vibrator.vibrate(150)
                    if copyPassword then
                        service.copy(password)
                    end
                    if saveToFavorites then
                        service.addFavorites(password)
                    end
                    if sharePassword then
                        local intent = Intent(Intent.ACTION_SEND)
                        intent.setType("text/plain")
                        intent.putExtra(Intent.EXTRA_TEXT, password)
                        service.startActivity(Intent.createChooser(intent, "Como você deseja compartilhar a senha?"))
                    end
                end
            else
                service.asyncSpeak("Insira o comprimento da senha")
vibrator.vibrate(200)
            end
            
            dlg.dismiss()
        end
    };
    {
        Button;
        text = "Sair";
        onClick = function()
            dlg.dismiss()
        end;
    };
}

dlg = LuaDialog(this)
dlg.setTitle("Criar senhas personalizadas")
dlg.setView(loadlayout(passwordGeneratorLayout))
dlg.show()